import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSignup, ThinkSignupParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkSignup(params: ThinkSignupParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSignup>>>(
    THINK_API_URL + '/think/think-signup/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkSignup(params?: ThinkSignupParam) {
  const res = await request.get<ApiResult<ThinkSignup[]>>(
    THINK_API_URL + '/think/think-signup',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkSignup(data: ThinkSignup) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkSignup(data: ThinkSignup) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkSignup(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkSignup(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-signup/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkSignup(id: number) {
  const res = await request.get<ApiResult<ThinkSignup>>(
    THINK_API_URL + '/think/think-signup/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
